#include <Wire.h>
#include "rgb_lcd.h"

rgb_lcd lcd;

// Format komendy wejściowej:
//   1) R:nnn
//   2) G:nnn
//   3) B:nnn
String inputString = "";
bool stringComplete = false;

int r = 0;
int g = 0;
int b = 0;

void setup() {
    Serial.begin(9600);
    lcd.begin(16, 2);
    lcd.setRGB(r, g, b);
}

void loop() {
  if (stringComplete) {
    int v = 100*(inputString[2]-'0') + 10*(inputString[3]-'0') + (inputString[4]-'0');

    if (inputString[0] == 'R') {
      r = v;
    } else if (inputString[0] == 'G') {
      g = v;
    } else if (inputString[0] == 'B') {
      b = v;
    }
    
    lcd.setRGB(r, g, b);
    
    Serial.print("Color set to (");
    Serial.print(r);
    Serial.print(",");
    Serial.print(g);
    Serial.print(",");
    Serial.print(b);
    Serial.println(")");

    inputString = "";
    stringComplete = false;
  }
}

void serialEvent() {
  while (Serial.available()) {
    char inChar = (char)Serial.read();
    if (inChar == '\n') {
      stringComplete = true;
    }
    inputString += inChar;
  }
}
